// assume cols > rows, if not, turn pic 90 degree please
// bar_data seperate with comment chars
// input *.bmp, color_plate in 00~255 grade.
// 99 bar_code *34 block
// count in: blocks not same scale, turn a angle, reverse
#include <stdio.h>
#include <string.h>
#define n1    2048                   // col
#define n2    1024                   // row
#define uninw   60                   // for sharpness, & backgroud
#define w99     99                   // processblock, 1st_data threshold
#define white    0                   // define 4 colors
#define green    1                   // color for test plot picture
#define red      2
#define black  255
unsigned char obits[n2][n1];         // raw data
unsigned char  bits[n2+320][n1];     // main processing pic
unsigned char  btmp[n2+320][n1];     // add curves, 16*20=320
unsigned char   bar[90][n1];         // get bar_line_data
unsigned char  sbar[90][n1];         // wave adjust
unsigned char  tbar[90][17*34+1];    // max block 34, 2+30+2; max jbar: 90
unsigned short    h[539],th[549];    // BMP 27+512
unsigned char h1[17]={200,200,200,200,200,200,200,200,0,200,0,200,0,200,0,0,0};
unsigned char h2[18]={200,200,200,200,200,200,200,0,200,0,0,0,200,0,200,0,0,200};
int work[n1],work1[n1];
int work2[n2];                 // position: 1st [row];  2nd [jbar]
int xbar[99];                  // 1st [jbar];  2nd [nblock]
int bargap, total, nblock;     // total:  code real_len
int jbar,ibar;                 // jbar: n_line_code, ibar===17*nblock+1
int istart;                    // last: sbar-->tbar,  0 0 0 istart ... [cols]
int rows,cols;
int u1,u2,v1,v2;               // 1st corner
int x1,x2,x3,x4,y1,y2,y3,y4;   // 2nd corner position of bits

float f1,f2,f3;                // f1: x_axis_slip, f2: scale
FILE *fp;
char sb[20];                   // file name

corner(u,v,x,y,zx,zy)          // input: u,v; output: x,y
int u,v,zx,zy, *x,*y;          // zx,zy   4 corner direction
{
  int i,j,q,r,s,t;
  for(r=0;r<rows/2;r++)        // ? rows/2 may changable
  for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
    s=u+i*zx; t=v+j*zy;
    if(s<0)s=0; if(s>cols-1)s=cols-1;
    if(t<0)t=0; if(t>rows-1)t=rows-1;
    if(bits[t][s]>uninw)       // continue find 45degree_direct 3 points>uninw
    if(bits[t+zy][s+zx]>uninw)               // may changable
    if(bits[t+zy*2][s+zx*2]>uninw)goto l10;
  }
l10:                           // distance 2 pixel of corner. find X,Y edge
  s+=zx*2; t+=zy*2;
  for(j=0;j<5;j++){ r=t-j*zy;
    if(r<0 || r>rows-1)break; if(bits[r][s]<uninw)break; }
  for(i=0;i<5;i++){ q=s-i*zx;
    if(q<0 || q>cols-1)break; if(bits[t][q]<uninw)break; }
  *x=q+zx;  *y=r+zy;
//printf("%d %d\n",*x,*y);
}

cross(x,y,color)               // plot cross mark.
int x,y,color;
{
  int i,j;
  for(j=y-5;j<=y+5;j++)if(j>=0 && j<n2)bits[j][x]=color;
  for(i=x-5;i<=x+5;i++)if(i>=0 && i<n1)bits[y][i]=color;
}

outbmp(f1)                     // output bits_file with mark & curve
char *f1;
{
  FILE *fp;
  int i,j,k=(cols+3)/4*4;
  fp=fopen(f1,"wb");  fwrite(h,2,539,fp);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(btmp[rows-j-1],1,k,fp);  fclose(fp);
}

out3bmp(f1)                         // out put 3 MAP of BMP
char *f1;                           // 1. bar, after wave_adjust
{                                   // 2. raw map
  FILE *fp;                         // 3. out_bar, sb.bmp,
  int i,j,k=(cols+3)/4*4,u,v,w;
  w=f2+0.4;
  h[11]=rows+jbar*(bargap+w);
  fp=fopen(f1,"wb");  fwrite(h,2,539,fp);
// tbar
  for(i=0;i<jbar;i++){
    for(j=0;j<cols;j++)btmp[i][j]=255;
    for(j=0;j<ibar;j++){
      u=255-tbar[jbar-i-1][j];
      for(v=0;v<w;v++)btmp[i][istart+j*w+v]=u;
    }
    for(j=0;j<w;j++)fwrite(btmp[i],1,k,fp);
  }
// obits, due to BMP_color_plate changed, red=253, green=254, not appear
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(obits[j][i]>=253)obits[j][i]=255;
  for(j=0;j<rows;j++)fwrite(obits[rows-j-1],1,k,fp);
// sbar
  for(i=0;i<jbar;i++){
    for(v=0;v<bargap;v++){
      for(j=0;j<cols;j++)btmp[i][j]=255-sbar[jbar-i-1][j];
/*                                          use for locate point.
      if(v!=bargap/2) for(u=0;u<cols;u++){
        if(btmp[i][u]==253)btmp[i][u]=255;
        if(btmp[i][u]==254)btmp[i][u]=0;
      }
*/
      fwrite(btmp[i],1,k,fp);
    }
  }
  fclose(fp);
}

filter(kk)                         // de_noise, median_method
int kk;
{
  int i,j,k,i1,j1,i2,j2,f;
  unsigned char a[81],c;           // max f=4; 9*9 filter
  f=kk; if(f>4)f=4;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
  for(j=f;j<rows-f;j++)for(i=f;i<rows;i++){    k=0;
    for(j1=j-f;j1<=j+f;j1++)for(i1=i-f;i1<=i+f;i1++)a[k++]=btmp[j1][i1];
    for(i2=0;i2<k-1;i2++)for(j2=i2+1;j2<k;j2++)if(a[i2]>a[j2]){
      c=a[i2]; a[i2]=a[j2]; a[j2]=c;
    }
    bits[j][i]=a[k/2];
  }
}

smooth(w,g,n)                       // for bargap line, in order to get
int *w,*g,n;                        // suitable line between bargaps.
{                                   // should be change less.
  int i,k=1;                        // 1st_line not take part in smooth,
  for(i=0;i<n;i++)g[i]=w[i];        // it's value too larger
  for(i=1;i<n-1;i++){
    if(g[i-1]==0)continue;
    if(k){ k=0;  continue; }
    if(g[i+1]==0)break;
    w[i]=(g[i-1]+g[i+1]+g[i]*2)/4;
  }
}

filter_line(a,t,w,k)               // k=1,2,3..7 --> 3,5,7..15 window
int *a,*t,w,k;                     // a[n];  t[n] is temp array
{
  int i,j,k2,m,b[15],i1,j1,k1;
  if(k<=0 || k>7)return;
  k2=k+k+1;
  for(i=0;i<w;i++)t[i]=a[i];
  for(i=k;i<w-k;i++){
    for(j=i-k,m=0;j<=i+k;j++)b[m++]=t[j];
    for(i1=0;i1<k2-1;i1++)for(j1=i1+1;j1<k2;j1++)if(b[i1]>b[j1]){
      k1=b[i1]; b[i1]=b[j1]; b[j1]=k1;
    }
    a[i]=b[k];
  }
}

adjustw2(w,v,n)
int *w,*v,n;
{
  int i,j=0,k,z[32],l,oldi=-2;
  float x;

  x=(float)(w[n-1]-w[0]); x/=(float)(n-1);
  printf("  bar_gap_pixel: %5.2f\n",x);
  bargap=x+0.5;
  k=(int)(x+0.5); w[0]=w[1]-k;  w[n-1]=w[n-2]+k;
  for(i=0;i<n;i++)v[i]=w[i+1]-w[i];
//for(i=0;i<n;i++)printf("%d_%d ",w[i],v[i]); printf("--%d\n",n);
  for(i=0;i<n-2;i++){
    k=w[i+1]-w[i]; k-=(int)x;
    if(k>1){ z[j]=i; if(i!=oldi+1)j++; oldi=i; }
  }
//for(i=0;i<j;i++)printf("%d",z[i]); printf("\n");
  if(j){
    for(i=l=0;i<j;i++){
      k=v[z[i]]-v[z[i]+1]; if(k<0)k=-k;
      if(k>1){
        l++; if(v[z[i]]>v[z[i]+1])w[z[i]+1]--; else w[z[i]+1]++;
        continue;
      }
      k=v[z[i]]-v[z[i]-1]; if(k<0)k=-k;
      if(k>1){
        l++; if(v[z[i]]>v[z[i]-1])w[z[i]]++; else w[z[i]]--;
      }
    }
//if(l)for(i=0;i<n;i++)printf("%d_%d ",w[i],w[i+1]-w[i]); printf("\n");
  }
}

processblock(int *a, int w, float f2, int *b, int jbar, int block)
{
  int i,j,j1,j2,k,k2,level=120;
  float f,x;
// up level
  for(i=0;i<w;i++)if(a[i]<level)a[i]=0;
//filter_line(a,b,w,2);
// delete small energy point.
l00:
  for(i=0;i<w;i++)b[i]=a[i];  b[w]=255;
  i=0;
l05:
  while(b[i]==0)i++; if(i>=w-3)goto l06;
  k=0; for(j=i;j<w;j++)if(b[j])k+=b[j]; else break;
                     if(j==w)goto l06;
  if(k<255)for(k=i;k<j;k++)a[k]=0;       // add energy <255, delete
  i=j;
  goto l05;
l06:
// check 00 apear 4 times;
  j=0; for(i=0;i<w;i++)if(a[i]==0){ if(k==1){ j++; k=0;}} else k=1;
if(j<4)printf("*");
if(j>4)printf("#%d_%d",jbar,block);
  if(j>4){                // up white level
    level+=20; if(level>180)return;
    for(i=0;i<w;i++)if(a[i]<level)a[i]=0;
    goto l00;
  }
  if(j<4){                // expand lost zero;
//  for(i=0;i<w;i++)printf("%d ",a[i]); printf("\n");
    for(i=0;i<w;i++)b[i]=a[i];
    i=0;
l10:
    i++; if(i>=w)goto l15;
    if(b[i])goto l10;
    for(j=i-1;j>i-4;j--)if(j>=0)b[j]=255;
    for(j=i;j<w;j++)if(b[i])break; else b[i]=255;
    for(j=i;j<i+3;j++)b[j]=255;
    i+=2; goto l10;
l15:
    k=b[2];
    for(i=3;i<w;i++)if(b[i]<k){ k=b[i]; j=i; }
    a[j]=0;
  }
  i=0;
l20:
  i++; if(i>=w)return;
  if(a[i])goto l20;             // find 0
  j=i; while(a[i]==0)i++;       // find 1
  f=i-j; f/=f2; x=f;  while(f>1.)f-=1.;
  j1=j-1; j2=i;
  k=(1.-f)*f2; if(k==0)goto l20;
  if(x<1.)goto l30;             // for signal mark
  if(x>2.)goto l20;             // enough wode
  k2=f2/2.; if(k>k2)goto l20;
l30:
//  if(a[j1]>a[j2]){ a[j2]=0; i++;}  else a[j1]=0;

  if(k==1){ if(a[j1]>a[j2]){ a[j2]=0; i++;}  else a[j1]=0;  k--; }
  if(k>=2){ a[j1--]=a[j2++]=0; i++; k-=2; }
  if(k>0)goto l30; else goto l20;
}

pcurve(a,k,color,z)
unsigned char a[32][2048]; int k,color,z;
{
  int i,j;
  for(i=0;i<cols;i++){ j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bits[j][i]=2; }
  for(i=0;i<cols;i++){ j=8-(a[k][i]>>5); bits[j+rows][i]=color;  }
  if(z){ rows+=12; h[11]=rows; }
}


process17(int *a, int n)
{
  int i,j,k,m,d[9];                // 9 change_pointer
  float f,b[8],c[8];
  f=17./n;  d[0]=0; d[8]=n;
  for(j=1,i=2;i<n-3;i++){ if(a[i]!=a[i+1])d[j++]=i;  if(j==8)break; }  //???
  for(j=0;j<9;j++)d[j]=d[j+1]-d[j];
  if(a[n-1])d[7]--;
  for(j=0;j<8;j++){
    c[j]=b[j]=d[j]*f;
    if(b[j]<1.)b[j]=1.; if(b[j]>6.)b[j]=6.;
  }
  for(j=i=0;j<8;j++){ d[j]=b[j]+0.5; i+=d[j]; }
  if(i!=17){
    for(j=0;j<8;j++)printf("%4.2f ",b[j]);
    for(j=0;j<8;j++)printf("%d ",d[j]);
    k=m=0; if(a[n])k=1; if(a[n-1])m=1;
    printf("  %d %d %d\n",i,k,m);
  }
l10:
  for(i=k=m=0;i<8;i++){ m=255-m; for(j=0;j<d[i];j++)a[k++]=m; }
}

expand2()
{
  int i,j,k;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j*2][i*2]=obits[j][i];
  rows=rows*2-1; cols=cols*2-1;  h[9]=cols; h[11]=rows;
  printf("PICsize changed: ");
  for(j=1;j<rows;j+=2)for(i=0;i<cols;i+=2)
                    bits[j][i]=(bits[j-1][i]>>1)+(bits[j+1][i]>>1);
  for(j=0;j<rows;j+=2)for(i=1;i<cols;i+=2)
                    bits[j][i]=(bits[j][i-1]>>1)+(bits[j][i+1]>>1);
  for(j=1;j<rows;j+=2)for(i=1;i<cols;i+=2){
      k=bits[j-1][i-1]+bits[j-1][i+1]+bits[j+1][i-1]+bits[j+1][i+1];
      bits[j][i]=k>>2;
  }
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)obits[j][i]=bits[j][i]; //for display
}

main(int ac, char **av)
{
  int i,j,k,u,v,w;
  int i1,i2,j1,j2;
  if(ac<2){
     printf("\n\t********** re_shape of pdf417 image **********\n");
     printf("\n\t                         jiang zhaoji 20110928\n");
     printf("\n\tUsage: c *.bmp [!]\n");
     printf("\n\t! means output middle processing images of BMP\n\n");
     return 0;
  }
  fp=fopen(av[1],"rb"); if(fp==0){printf("\n\tfile not found!\n"); return 1;}
  fread(h,2,539,fp);  for(i=0;i<539;i++)th[i]=h[i];
  cols=h[9]; rows=h[11];  k=(cols+3)/4*4;
// define color;
  h[535]=0xff00; h[536]=0;                     // coror 1: green
  h[533]=0;                                    // color 2: red
  if(cols>n1)cols=n1; if(rows>n2)rows=n2;      // take 2048*1024 max picture
  for(j=0;j<rows;j++)fread(&obits[rows-j-1][0],1,k,fp);  fclose(fp);
  printf("readin BMP_file: %s ",av[1]);

// loop pointer: if orion scale <=4; expand pic, do again
l00:
// white_black reverse, define background ~ 0
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=255-obits[j][i];
  printf(" %d*%d\n",cols,rows);

// sharpness pic, by using uninw, smooth backgroud,        sharpness WHITE
                                             // must donot sharpness BLACK
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<uninw)bits[j][i]=0;

//de_noise,  use 3*3 filter matrix,   1: 3*3,  2: 5*5pixels
  filter(1);

// loop pointer, for reverse pic.
l10:
// find 4 corner, roughly
  for(j=0;j<rows;j++)work[j]=0;                       // project in X
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)work[j]+=bits[j][i];
  for(j=0;j<rows;j++)work[j]/=cols;
  for(j=rows/2;j>=0;j--)  if(work[j]*2<work[j+1])break; v1=j; if(v1<0)v1=0;
  for(j=rows/2;j<rows;j++)if(work[j]*2<work[j-1])break; v2=j; if(v2==rows)v2--;
//for(j=0;j<rows;j++)printf("%d ",work[j]); printf("\n");
  for(i=0;i<cols;i++)work[i]=0;                       // project in Y
  for(i=0;i<cols;i++)for(j=0;j<rows;j++)work[i]+=bits[j][i];
  for(i=0;i<cols;i++)work[i]/=rows;
  for(i=0;i<cols;i++)  if(work[i])break; u1=i--; if(u1<0)u1=0;
  for(i=cols-1;i>0;i--)if(work[i])break; u2=i++; if(u2==cols)u2--;
  for(i=u1;i<cols/2;i++){  k=0;                       // calculte u1,u2 more
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u1=i;
  for(i=u2;i>cols/2;i--){  k=0;
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u2=i;
//for(i=0;i<cols;i++)printf("%d ",work[i]); printf("\n");
//printf("u1,u2  v1,v2: %d %d    %d %d\n",u1,u2,v1,v2);
// locate 4 corner in detail
  corner(u1,v1,&x1,&y1, 1, 1);   //0,0  ------>
  corner(u1,v2,&x2,&y2, 1,-1);   // |   x1,y1         x3,y3
  corner(u2,v1,&x3,&y3,-1, 1);   // |
  corner(u2,v2,&x4,&y4,-1,-1);   // v   x2,y2         x4,y4
//printf("%d %d %d %d    %d %d %d %d\n",x1,x2,x3,x4,y1,y2,y3,y4);

// if reverse pic
  k=(x1+x2)/2;  u=0;   w=(y2-y1)/2;
  for(j=y1;j<y2;j++)for(i=k;i<k+w;i++)u+=bits[j][i];
  k=(x3+x4)/2;  v=0;
  for(j=y3;j<y4;j++)for(i=k-w;i<k;i++)v+=bits[j][i];
//printf("%d %d\n",u,v);
  if(u<v){ printf("*** turn pic 180 degree\n");
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[rows-j-1][cols-i-1]=btmp[j][i];
    goto l10;
  }

// set coordination, two TAN is not the same
//y=(x-x1)*(y3-y1)/(x3-x1)+y1;
  f1=(float)(y3-y1); f1/=(x3-x1);
  f2=(float)(y4-y2); f2/=(x4-x2);
  f1=(f1+f2)/2.;                                    // get average X_slip
printf("slip:  %f   code_high: %d",f1,(y2-y1+y4-y3)/2);

// workout row_direction, how may lines of code_data, ie. jbar
  for(i=0;i<rows;i++)work2[i]=0;
  for(i=0;i<cols;i++)work[i]=-1;
  for(i=0;i<cols;i++){  j=(i-x1)*f1+y1; if(j>=0&&j<rows)work[i]=bits[j][i]; }
  for(k=y1+1;k<=y2+2;k++){
    for(i=0;i<cols;i++)work1[i]=-1;
    for(i=0;i<cols;i++){j=(i-x1)*f1+k; if(j>=0&&j<rows)work1[i]=bits[j][i]; }
    for(i=j1=0;i<cols;i++){
      j2=0; if(work[i]!=-1 && work1[i]!=-1)j2=work[i]-work1[i];
      if(j2<0)j2=-j2;  if(j2<30)j2=0; j1+=j2;
    }
    for(i=0;i<cols;i++)work[i]=work1[i];
    work2[k]=j1;
  }
//for(i=0;i<rows;i++){ printf("%6d",work2[i]); if(i%13==12)printf("\n"); }
//printf("\n");
  for(i=0;i<rows;i++)  if(work2[i])break; i1=i;
  for(i=rows-1;i>0;i--)if(work2[i])break; i2=i;
  for(i=i1+1;i<i2;i++) if(work2[i]==0)work2[i]=1;
  smooth(work2,work1,rows);  smooth(work2,work1,rows);
//for(i=0;i<rows;i++){ printf("%6d",work2[i]); if(i%13==12)printf("\n"); }
//printf("\n");
  for(i=1,jbar=0;i<rows;i++){
    if(work2[i-1]==0) continue;
    if(work2[i+1]==0) break;
    if(work2[i]<work2[i-1] && work2[i]<work2[i+1]){
      work2[jbar++]=i-1;
      i++;  while(work2[i]<1000)i++;   // for gap large_type, ex: pdf417.bmp
    }
  }
  adjustw2(work2,work1,jbar);                      // jbar gotten

//each star x_position of bar[jbar][]
  f2=x1-x2; f2/=(y1-y2);
  for(i=0;i<jbar;i++) xbar[i]=x1-(y1-work2[i])*f2;
  for(k=0;k<jbar;k++){                             //take data to bar[jbar][]
    for(i=0;i<cols;i++){
      bar[k][i]=0;
      j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bar[k][i]=bits[j][i];
    }
  }

// total bar_num: jbar, data array: bar[jbar][cols], start at xbar[jbar]
// work2[jbar]= real line_number of bits, for plot only. save for a while
//-----------
// get scale, ie. block 1/17 pixel number, next get how may blocks
// each bar, has diff start_col in xbar[];           // total: bar length
  total=(x3-x1+x4-x2)/2; i=xbar[jbar/2];             //
  for(j=i+2;j<cols;j++)if(bar[jbar/2][j]<uninw)break;
  f2=(j-i)/8.;                         // use first block's 8 unit, roughtly f2
  f2*=17; nblock=total/f2+0.5;                       // get nblock
  f2=total; f2/=(nblock*17+1);                       // detail scale: f2
  w=f2*17.+0.5;                                      // 1 block data_length
  ibar=nblock*17+1;
  printf("bar_len: %d  blocks: %d  real_scale: %7.4f\n",total,i,f2);

//if expand pic *2,
  k=f2+0.5; if(k<2){ printf("after expanding, calculate error\n"); return 1; }
  if(k<=4){ expand2(); goto l00;  }                   // redo

//  bar[jbar][cols]  get from bits
// sbar[jbar][cols], after processblock,
// tbar[jbar][17*nblock+1]  after process17
//adjust bar[jbar][] Y_direction slip
  i1=xbar[jbar/2];                              // i1 ???
  for(v=0;v<jbar;v++){
    k=xbar[v]-i1;
    for(i=0;i<cols;i++)work[i]=bar[v][i];       //  bar adjust Y_direction
    for(i=0;i<cols;i++)bar[v][i]=work[i+k];
    for(i=0;i<i1-2;i++)bar[v][i]=0;             // clear 2_ends
    for(i=cols-1;i>i1+total+2;i--)bar[v][i]=0;  // end,  need not clear.
  }

// re_project, cal f2, using bar[jbar][]
  for(i=0;i<cols;i++){
    for(j=k=0;j<jbar;j++)if(bar[j][i])k++; work[i]=k>(jbar/2)?1:0;
  }
  for(i1=0;i1<cols;i1++)  if(work[i1])break;  istart=i1;
  for(i2=cols-1;i2>0;i2--)if(work[i2])break;
  total=i2-i1+1;  f2=total; f2/=ibar;         w=f2*17.+0.5;
  printf("new_par: start: %d total %d   scale: %6.4f\n",istart,total,f2);

// adjust wave shape  -->sbar
  for(v=0;v<jbar;v++){
    for(j=0;j<=cols;j++)work[j]=bar[v][j];
    for(i=1;i<nblock-1;i++){                       // ignore start,end block
      j=istart+i*w-(f2+1.)/2.; if(j<0)j=0;
      for(k=j;k<j+3;k++)if(work[k]==0)break; if(k!=j+3)j=k;
      for(k=j;k<j+9;k++){ if(work[k]>w99)break; else work[k]=0; }  //clear edge
      if(i!=nblock)processblock(&work[k],w,f2,work1,v,i);
    }
    for(j=0;j<cols;j++)sbar[v][j]=work[j]?255:0;
  }

// get new xbar[], for block start_position
  for(i=0;i<=nblock;i++){
    k=i*17*f2+istart;
    if(work[k]==0){ for(j=k;j<k+20;j++)if(work[j])break; }
    else { for(j=k;j>=0; j--)if(work[j]==0)break; j++; }
    xbar[i]=j;                                     // xbar[] new means
  }

// shrink
  for(j=0;j<jbar;j++){
    for(i=0;i<17;i++)tbar[j][i]=h1[i];                    // put line_head
    for(v=1,i=17;v<nblock-1;v++){
//    other method, get data of tbar
//    f3=xbar[v+1]-xbar[v]; f3/=17.;
//    for(u=0;u<17;u++){
//      k=u*f3+xbar[v]+f3*.5+0.5;
//      tbar[j][i++]=sbar[j][k];
//      sbar[j][k]=sbar[j][k]?1:2;                        // print mark
//    }
      for(k=xbar[v],w=0;k<xbar[v+1];k++)work[w++]=sbar[j][k];
              work[w]=sbar[j][xbar[v]-1];                 // for p17 jduge
      process17(work,w);
      for(u=0;u<17;u++)tbar[j][i++]=work[u];
    }
    for(k=0;k<18;k++)tbar[j][i++]=h2[k];                  // put line_end
  }

// save data of tbar(BMP)
  sprintf(sb,"s%s",av[1]);
  fp=fopen(sb,"wb");
  th[9]=ibar; th[11]=jbar*2;
  fwrite(th,2,539,fp); k=(ibar+3)/4*4;    // must 1 blank line
  for(j=0;j<jbar;j++){
    for(i=0;i<ibar;i++)tbar[jbar][i]=255-tbar[jbar-j-1][i];  // grey reverse
    fwrite(tbar[jbar],1,k,fp);
    fwrite(tbar[jbar],1,k,fp);
  }
  fclose(fp);
  printf("re_shape file produced %s !\n",sb);

   if(ac>2)return 0;                      // will be ac<3
// output 3_map  BMP
  out3bmp("bb.bmp",istart);

// mark on bits_pic,  can track, start position, add position mark
// plot curve            use bar[0-16][] data
  for(k=0;k<jbar;k++){
    for(i=0;i<cols;i++){
      j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bits[j][i]=red;
    }
  }
  cross(u1,v1,red);  cross(u1,v2,red);  cross(u2,v1,red);  cross(u2,v2,red);
  cross(x1,y1,green);cross(x2,y2,green);cross(x3,y3,green);cross(x4,y4,green);
  for(i=j=0;i<jbar;i++){
    pcurve(bar,i,red,j);    j=1-j;
    pcurve(sbar,i,green,j); j=1-j;
  }
  outbmp("b.bmp");

//if link job
  sprintf(sb,"a s%s 99",av[1]); system(sb);
  return 0;
}
