#include <stdio.h>
#define n1  4096
#define n2  4032
#define n11 2048
#define n22 2016
#define m1 n1-1
#define m2 n2-1
#define n0 100
char  head[72][80],f1[30];
FILE  *fp;
float a[n1*n2],f[n1*n2];
float d[n2][n1];
int ccdno,idate;

main(ac,av)
int ac; char *av[];                        
{
  int   i,j,k;
  float sky,s;
  if(ac<3){
    printf("\n\t ****** flat,cross,corner correct *****\n");
    printf("\n\tUsage: p4 flatfile datafile ...\n");
    printf("\n\tdo /flat, 4 gates cross correct, smooth 4 corner\n\n"); 
    exit(0);
  }
// readin flat
  strcpy(f1,av[1]);   j=nindex(f1,".");
  if(j>0)strcpy(&f1[j],".fit"); else strcat(f1,".fit");
  fp=fopen(f1,"rb"); if(fp==0){printf("\tflat not found: %s\n",f1); exit(0);}
  fread(head,72,80,fp);
  k=indexpos(head,"SUP_FLAT",72);
  if(k==72){printf("\tNot a flat file: %s\n",f1); exit(0); }
  fread(f,n1*n2,4,fp); fclose(fp); swap4(f,n1*n2*4);
  printf("flat readin !\n");

  for(i=2;i<ac;i++){
    strcpy(f1,av[i]);
    printf("%3d: %s  ",i-1,f1);
    sscanf(&f1[1],"%d",&idate);  if(idate>5700)idate=0;
    fp=fopen(f1,"rb"); if(fp==0){printf("not found: %s\n",f1); continue; }
    if(f1[0]!='e'){ printf("\n\tnot a un_flated file %s\n",f1);continue; }
    fread(head,72,80,fp);
    j=indexpos(head,"CCD_NO: ",72);
    sscanf(&head[j][23],"%d",&ccdno);                        
    fread(a,n1*n2,4,fp); fclose(fp); swap4(a,n1*n2*4);

    for(j=0;j<n1*n2;j++)a[j]/=f[j]; 

    getsky(a,&sky);
    sm(a,sky);
    k=indexpos(head,"SKYADU  ",72);
    sprintf(&head[k][0],"SKYADU  = %20.2f / ADU/pixel (sky) ",sky);
    for(j=0;j<21;j++)head[k][48+j]=32;
 
    f1[0]='p'; unlink(f1);
    printf("---> produce:  %s  sky: %f\n",f1,sky);
    fp=fopen(f1,"wb"); fwrite(head,80,72,fp);
    swap4(a,4*n1*n2); fwrite(a,4,n1*n2,fp); fclose(fp);
  }
}

getsky(a,sky)
float a[n2][n1],*sky; 
{
// j 66+  0-400 700-1100 1400-1800 2100-2500 2800-3200 3500-3900 
// i 48+  0-400 720-1120 1440-1840 2160-2560 2880-3280 3600-4000
  float t[36];              // choice min
  short b[400*400];
  float x,s;
  int   i,j,k;
  int   i1,j1,i2,j2,l=0;
  j2=4032; i2=48; if(ccdno==4 && idate){ j2=2016; i2=2160; }
  for(j1=66;j1<j2;j1+=700)for(i1=i2;i1<4096;i1+=720){
    k=0;
    for(j=j1;j<j1+400;j++)for(i=i1;i<i1+400;i++){
      x=a[j][i]; if(x<32767. && x>0.)b[k++]=x;
    }
    white_black(b,1,k,&t[l++],&s);
  }
  for(i=0;i<l-1;i++)for(j=i+1;j<l;j++)if(t[i]>t[j]){
    x=t[i]; t[i]=t[j]; t[j]=x;
  }
  *sky=t[0];
  if(ccdno==4 && idate){          // other 3 part as 0. 
    for(j=2016;j<4032;j++)for(i=0;i<4096;i++)a[j][i]=0.;
    for(j=0;j<2016;j++)for(i=0;i<2048;i++)a[j][i]=0.;
  }
}

sm(a,sky)
float a[n2][n1],sky; 
{
  int i,j,k;
  float c4[n0][n0],c;                 // corner correct
  if(ccdno==4 && idate)return;
  if(ccdno==1){ c=-1.67e-7;
// bad_line
    for(i=2048;i<2756;i++)a[570][i]=(a[571][i]+a[569][i])*0.49; //bad line
// copy file
    for(j=0;j<n2;j++)for(i=0;i<n1;i++)d[j][i]=a[j][i];
// 1  3
// 2  4     
// correct 4 
    for(j=n22;j<n2;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*((m2-j)*c+0.00035); //1
    for(j= 0;j<n22;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   (    j* c+0.00035); //2
    for(j=n22;j<n2;j++)
             for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   ((m2-j)*c+0.00077); //3
// corrcet 3
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   0.00022;  //1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*0.00035;  //2
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   0.00055;  //4
// corrcet 2
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00005;  //1
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00006;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00001;  //4
// corrcet 1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00005;  //2
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00005;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00001;  //4
  }
  if(ccdno==2){  c=1.e-7;
// copy file
    for(j=0;j<n2;j++)for(i=0;i<n1;i++)d[j][i]=a[j][i];
// 1  3
// 2  4     
// correct 4 
    for(j=n22;j<n2;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*((m2-j)*c+0.00020); //1
    for(j= 0;j<n22;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   (    j* c+0.00020); //2
    for(j=n22;j<n2;j++)
             for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   ((m2-j)*c+0.00041); //3
// corrcet 3
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   0.00022;  //1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*0.00020;  //2
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   0.00050;  //4
// corrcet 2
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00000;  //1
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00000;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00000;  //4
// corrcet 1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00005;  //2
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00005;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00001;  //4
  }
  if(ccdno==3){  c=0.;
// copy file
    for(j=0;j<n2;j++)for(i=0;i<n1;i++)d[j][i]=a[j][i];
// 1  3
// 2  4     
// correct 4 
    for(j=n22;j<n2;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*((m2-j)*c+0.00050); //1
    for(j= 0;j<n22;j++)
             for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   (    j* c+0.00040); //2
    for(j=n22;j<n2;j++)
             for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   ((m2-j)*c+0.00040); //3
// corrcet 3
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[j][m1-i]*   0.00000;  //1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][m1-i]*0.00000;  //2
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][i]*   0.00000;  //4
// corrcet 2
    for(j=n22;j<n2;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00024;  //1
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00010;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00008;  //4
// corrcet 1
    for(j= 0;j<n22;j++)for(i= 0;i<n11;i++)a[j][i]-=d[m2-j][i]*   0.00050;  //2
    for(j=n22;j<n2;j++)for(i=n11;i<n1;i++)a[j][i]-=d[j][m1-i]*   0.00020;  //3
    for(j= 0;j<n22;j++)for(i=n11;i<n1;i++)a[j][i]-=d[m2-j][m1-i]*0.00020;  //4
  }
// corner
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)c4[j][i]=a[m2-j][i];
  corner(c4,sky); for(j=0;j<n0;j++)for(i=0;i<n0;i++)a[m2-j][i]=c4[j][i];     //1
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)c4[j][i]=a[j][i];
  corner(c4,sky); for(j=0;j<n0;j++)for(i=0;i<n0;i++)a[j][i]=c4[j][i];        //2
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)c4[j][i]=a[m2-j][m1-i]; 
  corner(c4,sky); for(j=0;j<n0;j++)for(i=0;i<n0;i++)a[m2-j][m1-i]=c4[j][i];  //3
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)c4[j][i]=a[j][m1-i];
  corner(c4,sky); for(j=0;j<n0;j++)for(i=0;i<n0;i++)a[j][m1-i]=c4[j][i];     //4
}

x2med(d,j1,i1,n,nn)
float d[n0][n0]; int j1,i1,n,nn;
{ 
  float a[81],z;
  int i,j,k,m;
  m=n/2; if(m<1)m=1; if(m>4)m=4;
  k=0;
  for(j=j1-m;j<j1+m;j++)for(i=i1-m;i<i1+m;i++){
    if(j<0 || j>=nn )continue;
    if(i<0 || i>=nn )continue;
    a[k++]=d[j][i];
  } 
  for(i=0;i<k-1;i++)for(j=i+1;j<k;j++)if(a[i]>a[j]){
    z=a[i]; a[i]=a[j]; a[j]=z;
  }
  z=a[k/2];
  return(z);
}

corner(b,sky)
float b[n0][n0],sky;
{
  int i,j,k;
  float s,t[4],z;
  float c[25],d[n0][n0],e[n0][n0];
  k=0; for(j=n0-5;j<n0;j++)for(i=n0-5;i<n0;i++)c[k++]=b[j][i];
  for(i=0;i<24;i++)for(j=i+1;j<25;j++)if(c[i]>c[j]){z=c[i]; c[i]=c[j]; c[j]=z;} 
  t[0]=c[12];
  k=0; for(j=n0-55;j<n0-50;j++)for(i=n0-5;i<n0;i++)c[k++]=b[j][i];
  for(i=0;i<24;i++)for(j=i+1;j<25;j++)if(c[i]>c[j]){z=c[i]; c[i]=c[j]; c[j]=z;} 
  t[1]=c[12];
  k=0; for(j=n0-5;j<n0;j++)for(i=n0-55;i<n0-50;i++)c[k++]=b[j][i];
  for(i=0;i<24;i++)for(j=i+1;j<25;j++)if(c[i]>c[j]){z=c[i]; c[i]=c[j]; c[j]=z;} 
  t[2]=c[12];
  t[3]=sky;
  for(i=0;i<3;i++)for(j=i+1;j<4;j++)if(t[i]>t[j]){z=t[i]; t[i]=t[j]; t[j]=z;} 
  s=t[1];
  for(j=0;j<n0;j++)for(i=0;i<n0;i++){ 
    z=s-b[j][i]; if(z<-s)z=-s; if(z>s)z=s; d[j][i]=z; }
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)e[j][i]=x2med(d,j,i,9,n0);
  for(j=0;j<n0;j++)for(i=0;i<n0;i++)if(i+j<160)b[j][i]+=e[j][i];
}
